// Example use of LCD3Wire library
// Almost a carbon-copy of LCD4BitExample.pde
#include <LiquidCrystal.h> 


LiquidCrystal lcd(8, 9, 4, 5, 6, 7);  // D-Robotics LCD keypad shield 

void setup() {

  lcd.clear();
  lcd.begin(16,2); 

  //creating the custom fonts:
  lcd.commandWrite(B01001000);  // set cgram
  static byte chars[] PROGMEM ={
    B11111,B00000,B11111,B11111,B00000,
    B11111,B00000,B11111,B11111,B00000,
    B11111,B00000,B11111,B11111,B00000,
    B00000,B00000,B00000,B11111,B00000,
    B00000,B00000,B00000,B11111,B00000,
    B00000,B11111,B11111,B11111,B01110,
    B00000,B11111,B11111,B11111,B01110,
    B00000,B11111,B11111,B11111,B01110  };



  for(byte x=0;x<5;x++)
  {
    byte a=(x+1<<3)|0x40;

    for(byte y=0;y<8;y++)
    {
      lcd.createChar(a++); //write the character data to the character generator ram
      lcd.print(pgm_read_byte(&chars[y*5+x]));
    }
  }



  lcd.commandWrite(B00000001);  // clear display, set cursor position to zero
  lcd.commandWrite(B10000000);  // set dram to zero


}
char bignumchars1[]={
  4,1,4,0, 1,4,32,0, 3,3,4,0, 1,3,4,0, 4,2,4,0,   4,3,3,0, 4,3,3,0, 1,1,4,0,   4,3,4,0, 4,3,4,0};
char bignumchars2[]={
  4,2,4,0, 2,4,2,0,  4,2,2,0, 2,2,4,0, 32,32,4,0, 2,2,4,0, 4,2,4,0, 32,32,4,0, 4,2,4,0, 2,2,4,0};


void loop() {  

  for(int x = 0;x<10;x++){

    lcd.clear();
    lcd.cursorTo(0);
    lcd.printIn(bignumchars1+x*4);

    lcd.cursorTo(1);
    lcd.printIn(bignumchars2+x*4);

    delay(1000);
  }
}



