//http://www.arduino.cc/cgi-bin/yabb2/YaBB.pl?num=1265696343

/*
A set of custom made large numbers for a 16x2 LCD using the
 LiquidCrystal librabry. Works with displays compatible with the
 Hitachi HD44780 driver.
 
 Made by Michael Pilcher
 2/9/2010
 */

// include the library
#include <LiquidCrystal.h>

// initialize the interface pins
LiquidCrystal lcd(8, 9, 4, 5, 6, 7);  // D-Robotics LCD keypad shield 

// the 8 arrays that form each segment of the custom numbers
byte C0[8] =
{
  B11111,
  B11111,
  B11111,
  B00000,
  B00000,
  B00000,
  B00000,
  B00000
};
byte C1[8] =
{
  B00000,
  B00000,
  B00000,
  B00000,
  B00000,
  B11111,
  B11111,
  B11111
};
byte C2[8] =
{
  B00000,
  B00000,
  B00000,
  B00000,
  B00000,
  B11100,
  B11100,
  B11100
};
byte C3[8] =
{
  B11111,
  B11111,
  B11111,
  B00000,
  B00000,
  B00000,
  B11111,
  B11111
};
byte C4[8] =
{
  B11100,
  B11100,
  B11100,
  B00000,
  B00000,
  B00000,
  B00000,
  B00000
};
byte C5[8] =
{
  B00011,
  B00011,
  B00011,
  B00011,
  B00011,
  B11111,
  B11111,
  B11111
};
byte C6[8] =
{
  B11100,
  B11100,
  B11100,
  B11100,
  B11100,
  B11100,
  B11100,
  B11100
};
byte C7[8] =
{
  B11100,
  B11100,
  B11100,
  B00000,
  B00000,
  B00000,
  B11100,
  B11100
};


// loop counter
int x = 0;


void setup()
{
  // assignes each segment a write number
  lcd.createChar(0,C0);
  lcd.createChar(1,C1);
  lcd.createChar(2,C2);
  lcd.createChar(3,C3);
  lcd.createChar(4,C4);
  lcd.createChar(5,C5);
  lcd.createChar(6,C6);
  lcd.createChar(7,C7);

  // sets the LCD's rows and colums:
  lcd.begin(16, 2);

}

void custom1()
{ // uses segments to build the number 0
  lcd.setCursor(x, 0); // set cursor to column 0, line 0 (first row)
  lcd.write(0);  // call each segment to create
  lcd.write(255);  // top half of the number
  lcd.write(32);
  lcd.setCursor(x, 1); // set cursor to colum 0, line 1 (second row)
  lcd.write(1);  // call each segment to create
  lcd.write(255);  // bottom half of the number
  lcd.write(2);
}

void custom2()
{
  lcd.setCursor(x,0);
  lcd.write(0);
  lcd.write(3);
  lcd.write(6);
  lcd.setCursor(x, 1);
  lcd.write(255);
  lcd.write(1);
  lcd.write(2);
}

void custom3()
{
  lcd.setCursor(x,0);
  lcd.write(3);
  lcd.write(3);
  lcd.write(6);
  lcd.setCursor(x, 1);
  lcd.write(1);
  lcd.write(5);
  lcd.write(6);
}

void custom4()
{
  lcd.setCursor(x,0);
  lcd.write(255);
  lcd.write(1);
  lcd.write(2);
  lcd.setCursor(x, 1);
  lcd.write(32);
  lcd.write(255);
  lcd.write(32);
}

void custom5()
{
  lcd.setCursor(x,0);
  lcd.write(255);
  lcd.write(3);
  lcd.write(7);
  lcd.setCursor(x, 1);
  lcd.write(1);
  lcd.write(5);
  lcd.write(6);
}

void custom6()
{
  lcd.setCursor(x,0);
  lcd.write(255);
  lcd.write(3);
  lcd.write(7);
  lcd.setCursor(x, 1);
  lcd.write(255);
  lcd.write(5);
  lcd.write(6);
}

void custom7()
{
  lcd.setCursor(x,0);
  lcd.write(0);
  lcd.write(0);
  lcd.write(6);
  lcd.setCursor(x, 1);
  lcd.write(32);
  lcd.write(255);
  lcd.write(32);
}

void custom8()
{
  lcd.setCursor(x,0);
  lcd.write(255);
  lcd.write(3);
  lcd.write(6);
  lcd.setCursor(x, 1);
  lcd.write(255);
  lcd.write(5);
  lcd.write(6);
}

void custom9()
{
  lcd.setCursor(x,0);
  lcd.write(255);
  lcd.write(3);
  lcd.write(6);
  lcd.setCursor(x, 1);
  lcd.write(1);
  lcd.write(5);
  lcd.write(6);
}

void custom0()
{
  lcd.setCursor(x,0);
  lcd.write(255);
  lcd.write(0);
  lcd.write(6);
  lcd.setCursor(x, 1);
  lcd.write(255);
  lcd.write(5);
  lcd.write(6);
}

void loop()
{
  custom0();    // displays custom 0 on the LCD
  x = x + 3;    // sifts cursor over 4 columns
  custom1();
  x = x + 3;
  custom2();
  x = x + 3;
  custom3();
  delay(4000);  // delay 4 seconds
  lcd.clear();  // clears the display
  x = 0;  // resets x to 0
  custom4();
  x = x + 3;
  custom5();
  x = x + 3;
  custom6();
  x = x + 3;
  custom7();
  delay(4000);
  lcd.clear();
  x = 0;
  custom8();
  x = x + 3;
  custom9();
  delay(4000);
  lcd.clear();
  x = 0;

} 


