#include <LiquidCrystal.h>


// simple sketch to display a digital clock on an LCD
// see the LiquidCrystal documentation for more info on this
// http://hacks2try.blogspot.com/2010/10/date-and-time-on-arduino-lcd-shield.html


int second=0, minute=0, hour=0, weekday=1; // declare time variables
// these time variables are declared globally so they can be used ANYWHERE in your program

LiquidCrystal lcd(8, 9, 4, 5, 6, 7);
int backLight = 13; // pin 13 will control the backlight

void setup(){
  pinMode(backLight, OUTPUT);
  digitalWrite(backLight, HIGH); // turn backlight on. Replace 'HIGH' with 'LOW' to turn it off.
}

void printDigits(byte digits){
  // utility function for digital clock display: prints preceding colon and leading 0
  lcd.print(":");
  if(digits < 10)
    lcd.print('0');
  lcd.print(digits,DEC);
}

void digitalClockDisplay(){
  lcd.clear();
  lcd.begin(16,2);
  lcd.setCursor(3,0);

  //lcd.print(" ");
  if(hour <10)
    lcd.setCursor(5,1);
  lcd.setCursor(4,1);

  // digital clock display of current time
  lcd.print(hour,DEC);
  printDigits(minute);
  printDigits(second);
}


void loop() {

  static unsigned long lastTick = 0; // set up a local variable to hold the last time we moved forward one second
  // (static variables are initialized once and keep their values between function calls)

  // move forward one second every 1000 milliseconds
  if (millis() - lastTick >= 1000) {
    lastTick = millis();
    digitalClockDisplay();
    second++;
  }

  // move forward one minute every 60 seconds
  if (second > 59) {
    minute++;
    second = 0; // reset seconds to zero
  }

  // move forward one hour every 60 minutes
  if (minute > 59) {
    hour++;
    minute = 0; // reset minutes to zero
  }

  // move forward one weekday every 24 hours
  if (hour > 23) {
    weekday++;
    hour = 0; // reset hours to zero
  }

  // reset weekdays on Saturday
  if (weekday > 7) {
    weekday = 1;
  }

}

