#include <LiquidCrystal.h>

// simple sketch to display a digital clock on an LCD
// see the LiquidCrystal documentation for more info on this
// http://hacks2try.blogspot.com/2010/10/date-and-time-on-arduino-lcd-shield.html


int second=0, minute=0, hour=0, weekday=1; // declare time variables
// these time variables are declared globally so they can be used ANYWHERE in your program

LiquidCrystal lcd(8, 9, 4, 5, 6, 7);  // D-Robotics LCD keypad shield
int backLight = 10; // pin will control the backlight

void setup(){
  //pinMode(backLight, OUTPUT);
  //digitalWrite(backLight, HIGH); // turn backlight on. Replace 'HIGH' with 'LOW' to turn it off.

  lcd.clear();
  lcd.begin(16,2);

  // test: current time
  hour=11;
  minute=59;
  weekday=3;
}

void loop() {
  // set up a local variable to hold the last time we moved forward one second
  // (static variables are initialized once and keep their values between function calls)
  unsigned long msbegin=millis();
  unsigned long msafter;

  printTime();
  printWeekday(weekday);
  nextSecond();

  checkButtons(); // runs a function that checks the setting buttons

    // wait one second = 1000 milliseconds
  msafter = millis();
  if (msafter < msbegin) { //Millis() reset after 9h due to overflow
    delay(1000);
  }
  else {
    delay(1000-(msafter-msbegin));
  }
}


void nextSecond() {
  second++;

  // move forward one minute every 60 seconds
  if (second > 59) {
    minute++;
    second = 0; // reset seconds to zero

    // move forward one hour every 60 minutes
    if (minute > 59) {
      hour++;
      minute = 0; // reset minutes to zero

      // move forward one weekday every 24 hours
      if (hour > 23) {
        weekday++;
        hour = 0; // reset hours to zero

        // reset weekdays on Saturday
        if (weekday > 7) {
          weekday = 1;
        }
      }
    }
  }
}


void printDigits(byte digits){
  // utility function for digital clock display: prints preceding colon and leading 0
  lcd.print(":");
  if(digits < 10)
    lcd.print('0');
  lcd.print(digits,DEC);
}

void printTime(){
  //  lcd.clear();
  //  lcd.begin(16,2);
  lcd.setCursor(4,1);

  if(hour <10)
    lcd.print(" ");
  // digital clock display of current time
  lcd.print(hour,DEC);

  printDigits(minute);
  printDigits(second);
}

void printWeekday (int dayNum) {
  // print a weekday, based on the day number
  lcd.setCursor(6,0);
  switch (dayNum) {
  case 1:  
    lcd.print ("Sunday   ");  
    break;
  case 2:  
    lcd.print ("Monday   ");  
    break;
  case 3:  
    lcd.print ("Tuesday  ");  
    break;
  case 4:  
    lcd.print ("Wednesday");  
    break;
  case 5:  
    lcd.print ("Thursday ");  
    break;
  case 6:  
    lcd.print ("Friday   ");  
    break;
  case 7:  
    lcd.print ("Saturday ");  
    break;
  }
}

void checkButtons() {
}




